﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Data;
using Infragistics.Web.UI.GridControls;
using System.Windows.Forms;

public partial class _Default : System.Web.UI.Page
{
    private Dictionary<string, Infragistics.Web.UI.SortDirection> sortedCols;
    private DataSet _ds;

    DataSet DataSource
    {
        get
        {
            _ds = Session["DataSource"] as DataSet;
            if (_ds == null)
            {
                _ds = GetData();
                Session["DataSource"] = _ds;

            }
            return _ds;
        }
        set
        {
            _ds = value;
            Session["DataSource"] = _ds;
        }
    }

    private DataSet _ds2 = new DataSet();
    DataSet DataSource2
    {
        get
        {
            _ds2 = Session["DataSource2"] as DataSet;
            if (_ds2 == null)
            {
                _ds2 = GetData2();
                Session["DataSource2"] = _ds2;

            }
            return _ds2;
        }
        set
        {
            _ds2 = value;
            Session["DataSource2"] = _ds2;
        }
    }

    /// <summary>
    /// Page_Load - Check if Dictionary in Session is null,
    ///     Add sortedCols to Dictionary if true
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void Page_Load(object sender, EventArgs e)
    {
        sortedCols = Session["sortedCols"] as Dictionary<string, Infragistics.Web.UI.SortDirection>;
        if (sortedCols == null)
            sortedCols = new Dictionary<string, Infragistics.Web.UI.SortDirection>();

        WebDataGrid1.DataSource = DataSource;
    }

    /// <summary>
    /// Test DataSet Sample 1
    /// </summary>
    /// <returns></returns>
    private DataSet GetData()
    {
        DataSet ds = new DataSet();

        DataTable dt = new DataTable("GridData");
        dt.Columns.Add("ID", typeof(int));
        dt.Columns.Add("Name", typeof(string));
        dt.Columns.Add("Amt1", typeof(int));
        dt.Columns.Add("Amt2", typeof(double));

        dt.Rows.Add(new object[] { 1, "Name 1", 10, 100.10 });
        dt.Rows.Add(new object[] { 5, "Name 5", 50, 100.50 });
        dt.Rows.Add(new object[] { 4, "Name 4", 40, 100.40 });
        dt.Rows.Add(new object[] { 3, "Name 3", 30, 100.30 });
        dt.Rows.Add(new object[] { 2, "Name 2", 20, 100.20 });

        ds.Tables.Add(dt);
        return ds;
    }

    /// <summary>
    /// Test DataSet Sample 2
    /// </summary>
    /// <returns></returns>
    private DataSet GetData2()
    {
        DataSet ds = new DataSet();

        DataTable dt = new DataTable("GridData");
        dt.Columns.Add("ID", typeof(int));
        dt.Columns.Add("Name", typeof(string));
        dt.Columns.Add("Amt1", typeof(int));
        dt.Columns.Add("Amt2", typeof(double));

        dt.Rows.Add(new object[] { 2, "Name 2", 20, 100.20 });
        dt.Rows.Add(new object[] { 1, "Name 1", 10, 100.10 });
        dt.Rows.Add(new object[] { 5, "Name 5", 50, 100.50 });
        dt.Rows.Add(new object[] { 4, "Name 4", 40, 100.40 });
        dt.Rows.Add(new object[] { 3, "Name 3", 30, 100.30 });

        ds.Tables.Add(dt);
        return ds;
    }

    /// <summary>
    /// WebDataGrid1_ColumnSorted - Fires when Column Header is 
    ///     clicked to sort grid by Column
    /// </summary>
    /// <param name="sender"></param>
    /// <param name="e"></param>
    protected void WebDataGrid1_ColumnSorted(object sender, Infragistics.Web.UI.GridControls.SortingEventArgs e)
    {
        var colSort = e.SortedColumns[e.Column.Key];
        
        WebDataGrid wdg = (WebDataGrid)sender;
        e.SortedColumns.Clear();

        // Check which DataSet is stored in Session
        if (Session["DS_NO"] == null)
            Session["DS_NO"] = 1;

        int ds_no = (int)Session["DS_NO"];

        // If DataSet is DataSet 1, set WebDataGrid to DataSource2
        if (ds_no == 1)
        {
            WebDataGrid1.DataSource = DataSource2;
            ds_no = 2;
        }
        else
        {
            WebDataGrid1.DataSource = DataSource;
            ds_no = 1;
        }
        Session["DS_NO"] = ds_no;

        // If sortedColumns is null or SortDirection is Descending, set SortDirection to Ascending
        //      else set SortDirection to Descending
        if (!sortedCols.ContainsKey(e.Column.Key))
        {
            sortedCols.Clear();
            colSort.Column.Header.TemplateContainer.Controls.Clear();
            colSort.Column.Header.TemplateContainer.Controls.Add(new LiteralControl { ID = "sortAsc", Text = colSort.Column.Header.Text + @"<img src='Images/ig_tblSortAsc.gif'/>" });
            sortedCols.Add(e.Column.Key, Infragistics.Web.UI.SortDirection.Ascending);
        }
        else
        {
            if (sortedCols[e.Column.Key] == Infragistics.Web.UI.SortDirection.Ascending)
            {
                colSort.Column.Header.TemplateContainer.Controls.Clear();
                colSort.Column.Header.TemplateContainer.Controls.Add(new LiteralControl { ID = "sortDesc", Text = colSort.Column.Header.Text + @"<img src='Images/ig_tblSortDesc.gif'/>" });
                sortedCols[e.Column.Key] = Infragistics.Web.UI.SortDirection.Descending;
            }
            else
            {
                colSort.Column.Header.TemplateContainer.Controls.Clear();
                colSort.Column.Header.TemplateContainer.Controls.Add(new LiteralControl { ID = "sortAsc", Text = colSort.Column.Header.Text + @"<img src='Images/ig_tblSortAsc.gif'/>" });
                sortedCols[e.Column.Key] = Infragistics.Web.UI.SortDirection.Ascending;
            }
        }

        // Save sortedCols to Session
        Session["sortedCols"] = sortedCols;
    }
}
